-------------------------------------------------------------------------------
--! @file       DECN_M.vhd
--! @author     Ahmed Ferozpuri
--! @brief      Generic M integer value decrementer
-------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all ;

ENTITY DECN_M IS
GENERIC (N : INTEGER := 16;
			M : INTEGER := 1);
	PORT (	D : IN std_logic_vector(N-1 DOWNTO 0);
				clk, en, ld : IN std_logic;
				Q : OUT std_logic_vector(N-1 DOWNTO 0));
END DECN_M;
 
ARCHITECTURE behavioral OF DECN_M IS
	SIGNAL QS : STD_LOGIC_VECTOR(N-1 DOWNTO 0);
	
BEGIN
	
	Q <= QS;
	
	PROCESS (clk)
	BEGIN
		IF rising_edge(clk) THEN
			IF ld='1' THEN
				QS <= D;
			ELSIF en='1' THEN
				QS <= QS - M;
			END IF;
		END IF;
	END PROCESS;
END behavioral;