-------------------------------------------------------------------------------
--! @file       REGN_aqf.vhd
--! @author     Ahmed Ferozpuri
--! @brief      Generic N-bit register
-------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;

ENTITY REGN_aqf IS
GENERIC (N : INTEGER := 16);
	PORT (	D : IN STD_LOGIC_VECTOR(N-1 DOWNTO 0);
				clk, en : IN STD_LOGIC;
				Q : OUT STD_LOGIC_VECTOR(N-1 DOWNTO 0));
END REGN_aqf;
 
ARCHITECTURE behavioral OF REGN_aqf IS
BEGIN
	PROCESS (clk)
	BEGIN
		IF rising_edge(clk) THEN
			IF en='1' THEN
				Q <= D;
			END IF;
		END IF;
	END PROCESS;
END behavioral;