-------------------------------------------------------------------------------
--! @file       SIPON_M.vhd
--! @author     Ahmed Ferozpuri
--! @brief      Generic NxM SIPO
-------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;

ENTITY SIPON_M IS
GENERIC (N : INTEGER := 40;--SERIAL SIZE
			M : INTEGER := 80);--PARALLEL SIZE
	PORT (	clk, en : IN STD_LOGIC;
				D : IN STD_LOGIC_VECTOR(N-1 DOWNTO 0);
				Q : OUT STD_LOGIC_VECTOR(M-1 DOWNTO 0));
END SIPON_M;
 
ARCHITECTURE behavioral OF SIPON_M IS

SIGNAL QL : STD_LOGIC_VECTOR(M-1 DOWNTO 0);

BEGIN

	Q <= QL;
	
	PROCESS (clk)
	BEGIN
		IF rising_edge(clk) THEN
			IF en='1' THEN
--				QL(M-1 DOWNTO M-N) <= D;
--				QL(M-N-1 DOWNTO 0) <= QL(M-1 DOWNTO N);
				QL(N-1 DOWNTO 0) <= D;
				QL(M-1 DOWNTO N) <= QL(M-N-1 DOWNTO 0);
			END IF;
		END IF;
	END PROCESS;
END behavioral;